#!/usr/bin/perl -w

use strict;
use warnings;

use Data::Dumper;
use File::Temp qw(tempfile);
use Storable qw(store_fd retrieve);
use Digest::MD5;

my (%in, %text);
require "ldap-netgroups.pl";


my $server = 'localhost';
my $rootdn = 'cn=admin,ou=People,dc=skole,dc=skolelinux,dc=no';
my $basedn = 'dc=skole,dc=skolelinux,dc=no';

use constant INDEX => 0;

my @pass = qw(6 add oh ei);
my $password = $pass[2].$pass[0].$pass[1].$pass[3];

&ldap_connect( $server, $rootdn);

my @netgroups = ldap_get_netgroups($basedn);

my $struct = {
	netgroups => \@netgroups,
	queue => [],
	action => undef,
	heap => {}
};

if(1) {
   my ($fh, $filename) = tempfile( DIR => "./tmp" );
   store_fd( $struct, $fh);

   #Generete a digest.
   my $Md5 = Digest::MD5->new();
   binmode($fh);
   seek($fh,0,0);
   $Md5->addfile($fh);
   print "$filename: " . $Md5->hexdigest . "\n";
   close $fh;
} else {
   $struct = retrieve 'eKzTDrCGno';
}
my $netgroups = {};

foreach my $Netgroup ( @{ $struct->{netgroups} } ) {

	my $cn;
	my %hosts;
	my %membergroups;

	foreach my $attribute ( @{ $Netgroup->{asn}->{attributes} } ) {

		if($attribute->{type} eq 'cn') {

			$cn = $attribute->{vals}->[0]; 

		} elsif($attribute->{type} eq 'nisNetgroupTriple') {
		  
			foreach my $hostname ( @{ $attribute->{vals} } ) {
			        #We may want more info on a per-host basis in the future, so why not make it a hash.
				
				$hostname =~ /\((.*?),(.*?),(.*?)\)/;

		  		$hosts{$hostname} = { altered => 0, hostname => $1, username => $2, domainname => $3 };

			}

		} elsif($attribute->{type} eq 'memberNisNetgroup') {

			foreach my $netgroup ( @{ $attribute->{vals} } ) {
	
				#Ditto.
		  		$membergroups{$netgroup} = {};

			}
		} else {
			next;
		}
	} # attribute-loop.

	next unless($cn); #This shouldn't happen, really.

	$netgroups->{$cn} = {
				sync => 1,
				hosts => \%hosts,
				membergroups => \%membergroups,
	};
} # Netgroup-loop.

print Dumper($netgroups);

#print Dumper($struct->{netgroups});
